// disable warning message about converting double constant to float constant
#pragma warning(disable:4305)

#include "modelerdll.h"

#define VIEW_X  1
#define VIEW_Y  2
#define VIEW_Z  3

#define XROT_BEFORE  10
#define XROT_AFTER   11
#define TRANSLATE    12
#define SHOWLOCAL    13

#define FOO 20

#define FOO_PTR		40

MODEL("cylinder");

bool init(void *v)
{
//	printf("init args : %s\n", (char*)v);

    scale( VIEW_X, "x view", 0.0, 360.0, 1.0, 296.0 );
    scale( VIEW_Y, "y view", 0.0, 360.0, 1.0, 0.0 );
    scale( VIEW_Z, "z view", 0.0, 360.0, 1.0, 241.0 );
    
    scale( XROT_BEFORE, "x rotation before", 0.0, 360.0, 1.0, 0.0 );
    checkbox( TRANSLATE, "translate", 0 );
//   scale( XROT_AFTER, "x rotation after", 0.0, 0.004, 0.001, 0.0 );
    scale( XROT_AFTER, "x rotation after", 0.0, 360.0, 1.0, 0.0 );

    checkbox( SHOWLOCAL, "show local coordinates", 1 );

    curve( FOO, "translate z", -10.0, 10.0, 0.0 );

	// just demo how to store data in the animator
	char *msg=new char [32];
	strcpy(msg, "It's me!");
	ptr( FOO_PTR, msg );

	return true;
}

void redraw(int drawmode)
{
//  You can get the pointer back by calling get_ptr
//  This is only useful when you have multiple instances of the same object (DLL)
//	printf("cylinder::%s\n", (char *)get_ptr(FOO_PTR));

    int lighting;

	glMatrixMode( GL_MODELVIEW );
	glLoadIdentity();

    glTranslated( 0.0, 0.0, -15.0 );

    glRotated( get_control_f( VIEW_X ), 1.0, 0.0, 0.0 );
    glRotated( get_control_f( VIEW_Y ), 0.0, 1.0, 0.0 );
    glRotated( get_control_f( VIEW_Z ), 0.0, 0.0, 1.0 );

    glGetIntegerv( GL_LIGHTING, &lighting );
    glDisable( GL_LIGHTING );

    glLineWidth( 5.0 );
    
    if ( get_control_b( SHOWLOCAL ) )
    {
		glBegin( GL_LINES );
			glColor3d( 1.0, 0.7, 0.7 );
			glVertex3d( 0.0, 0.0, 0.0 );
			glVertex3d( 5.0, 0.0, 0.0 );
			glColor3d( 0.7, 1.0, 0.7 );
			glVertex3d( 0.0, 0.0, 0.0 );
			glVertex3d( 0.0, 5.0, 0.0 );
			glColor3d( 0.7, 0.7, 1.0 );
			glVertex3d( 0.0, 0.0, 0.0 );
			glVertex3d( 0.0, 0.0, 5.0 );
		glEnd();

		glPushMatrix();
		glRotated( get_control_f( XROT_BEFORE ), 1.0, 0.0, 0.0 );
		glTranslated( 0.01, 0.01, 0.01 );
		if ( get_control_b( TRANSLATE ) )
			glTranslated( 3.0, 1.0, get_control_d( FOO ) );
		glRotated( get_control_f( XROT_AFTER ), 1.0, 0.0, 0.0 );

		glBegin( GL_LINES );
			glColor3d( 1.0, 0.0, 0.0 );
			glVertex3d( 0.0, 0.0, 0.0 );
			glVertex3d( 2.0, 0.0, 0.0 );
			glColor3d( 0.0, 1.0, 0.0 );
			glVertex3d( 0.0, 0.0, 0.0 );
			glVertex3d( 0.0, 2.0, 0.0 );
			glColor3d( 0.0, 0.0, 1.0 );
			glVertex3d( 0.0, 0.0, 0.0 );
			glVertex3d( 0.0, 0.0, 2.0 );
		glEnd();

		glPopMatrix();
    }
    else
    {
		glBegin( GL_LINES );
			glColor3d( 1.0, 0.0, 0.0 );
			glVertex3d( 0.0, 0.0, 0.0 );
			glVertex3d( 5.0, 0.0, 0.0 );
			glColor3d( 0.0, 1.0, 0.0 );
			glVertex3d( 0.0, 0.0, 0.0 );
			glVertex3d( 0.0, 5.0, 0.0 );
			glColor3d( 0.0, 0.0, 1.0 );
			glVertex3d( 0.0, 0.0, 0.0 );
			glVertex3d( 0.0, 0.0, 5.0 );
		glEnd();
    }

    
    if ( lighting == GL_TRUE )
		glEnable( GL_LIGHTING );

    diffuse_color( 0.5, 0.5, 0.5 );

    glRotated( get_control_d( XROT_BEFORE ), 1.0, 0.0, 0.0 );
    if ( get_control_b( TRANSLATE ) )
		glTranslated( 3.0, 1.0, get_control_d( FOO ) );
    glRotated( get_control_d( XROT_AFTER ), 1.0, 0.0, 0.0 );

    glTranslated( 0.0, 0.0, -1.0 );

    cylinder( 2.0, 0.5, 0.5 );

}